Attribute VB_Name = "modRecycleSimple"
Option Explicit
'====================================================================
'
Private Declare Function SHFileOperation Lib "shell32.dll" Alias _
    "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40
Private Const FOF_NOCONFIRMATION = &H10
Private Const MAX_PATH As Long = 260
    
Private Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Boolean
    hNameMappings As Long
    lpszProgressTitle As String
End Type
    
Function Recycle(FileOrFolder As String) As Boolean
    Dim FileOperation As SHFILEOPSTRUCT
    Dim lReturn As Long
    
    If Len(Trim(FileOrFolder)) = 0 Then
        Recycle = False
        Exit Function
    End If
    
    If Dir(FileOrFolder, vbNormal) <> vbNullString Or _
            Dir(FileOrFolder, vbDirectory) <> vbNullString Then
            Recycle = True
            Exit Function
    End If
    
    With FileOperation
        .wFunc = FO_DELETE
        .pFrom = FileOrFolder
        '.fFlags = FOF_ALLOWUNDO
        '
        ' OR if you want to suppress the "Do You want
        ' to delete the file" message, use
        '
        .fFlags = FOF_ALLOWUNDO + FOF_NOCONFIRMATION

    End With

    lReturn = SHFileOperation(FileOperation)
    If lReturn = 0 Then
        Recycle = True
    Else
        Recycle = False
    End If

End Function


